]> arthur.barton.de Git - backup-script.git/blobdiff - bin/backup-script
First step to support multiple "backup types"
[backup-script.git] / bin / backup-script
index 2b9f7d7f2e91f4c45cdea62581bc211bbf1a934d..5c8ea3f33c73b24e612eb26b626cafb0c5e4000b 100755 (executable)
@@ -31,12 +31,14 @@ destinations=""
        || conf_d="/etc/backup-script.d"
 pre_exec=""
 post_exec=""
+default_backup_type="rsync"
 default_source_root="/"
 default_target="/var/backups"
 default_user="root"
 default_ssh_args_add=""
 default_rsync_args_add=""
 default_exclude_args_add=""
+default_exclude_dirs_add=""
 default_compress=1
 default_ping=1
 default_local=0
@@ -52,8 +54,7 @@ Usage() {
        echo
        echo "When no <system> is given, all defined systems are used."
        echo
-       echo "Configuration file is \"$conf\","
-       echo "using \"$conf_d\" as configuration directory."
+       echo -e $config_info
        echo
        exit 2
 }
@@ -156,7 +157,7 @@ CloneSubvolume() {
                zfs snapshot "$snapshot" || return 1
                link_name="$(echo "$snapshot" | cut -d@ -f2-)"
                ln -s \
-                       "$volume/.zfs/snapshot/$link_name" \
+                       "current/.zfs/snapshot/$link_name" \
                        "$(dirname "$volume")/$link_name"
                ;;
          *)
@@ -273,6 +274,15 @@ for conf in \
        [ -r "$conf" ] && break
 done
 
+# Read in configuration file
+config_info="Configuration file is \"$conf\""
+if [ -r "$conf" ]; then
+       source "$conf"
+else
+       config_info="${config_info} (not readable, using defaults)"
+fi
+config_info="${config_info},\nusing \"$conf_d\" as configuration directory."
+
 while [ $# -gt 0 ]; do
        case "$1" in
          "-n"|"--dry-run")
@@ -289,19 +299,25 @@ while [ $# -gt 0 ]; do
        esac
 done
 
-trap GotSignal SIGINT
-
 echo -n "Started: "; date
+echo -e "$config_info"
 
-# Read in configuration file
-if [ -r "$conf" ]; then
-       echo "Reading configuration: \"$conf\" ..."
-       source "$conf"
-else
-       echo "No configuration file found, using defaults."
+# Check rsync and its protocol version
+rsync=$(which "rsync" 2>/dev/null)
+if [ $? -ne 0 ]; then
+       echo "Failed to detect rsync(1)! Is it installed in your \$PATH?"
+       exit 1
+fi
+rsync_proto=$($rsync --version 2>/dev/null | head -n 1 | sed 's/.*  protocol version \([0-9]*\)$/\1/')
+if [ $? -ne 0 ]; then
+       echo "Failed to detect protocol version of $rsync!"
+       exit 1
 fi
+echo "Rsync command is $rsync, protocol version $rsync_proto."
 echo
 
+trap GotSignal SIGINT
+
 if [ $# -ge 1 ]; then
        for s in "$@"; do
                if [ ! -r "${conf_d}/$s" ]; then
@@ -345,7 +361,7 @@ if [ -n "$pre_exec" ]; then
 fi
 
 for f in $sys; do
-       [ -r "$f" -a -f "$f" ] || continue
+       [[ -r "$f" && -f "$f" ]] || continue
 
        fname=$(basename "$f")
        case "$fname" in
@@ -356,12 +372,14 @@ for f in $sys; do
 
        # Set global defaults
        system="$fname"
+       backup_type="$default_backup_type"
        user="$default_user"
        source_root="$default_source_root"
        target="$default_target"
        ssh_args_add="$default_ssh_args_add"
        rsync_args_add="$default_rsync_args_add"
        exclude_args_add="$default_exclude_args_add"
+       exclude_dirs_add="$default_exclude_dirs_add"
        compress="$default_compress"
        ping="$default_ping"
        local="$default_local"
@@ -374,7 +392,7 @@ for f in $sys; do
        post_exec_saved="$post_exec"
 
        # Compatibility with backup-pull(1) script: Set defaults
-       unset host
+       host=""
        unset source
        unset pre_exec
        unset post_exec
@@ -383,13 +401,13 @@ for f in $sys; do
        source "$f"
 
        # Compatibility with backup-pull(1) script: Fix up configuration
-       [ "$system" = "$fname" -a -n "$host" ] \
+       [[ "$system" = "$fname" && -n "$host" ]] \
                && system="$host"
-       [ "$source_root" = "$default_source_root" -a -n "$source" ] \
+       [[ "$source_root" = "$default_source_root" && -n "$source" ]] \
                && source_root="$source"
-       [ -z "$job_pre_exec" -a -n "$pre_exec" ] \
+       [[ -z "$job_pre_exec" && -n "$pre_exec" ]] \
                && job_pre_exec="$pre_exec"
-       [ -z "$job_post_exec" -a -n "$post_exec" ] \
+       [[ -z "$job_post_exec" && -n "$post_exec" ]] \
                && job_post_exec="$post_exec"
 
        # Compatibility with backup-pull(1) script: Restore global values ...
@@ -397,7 +415,7 @@ for f in $sys; do
        post_exec="$post_exec_saved"
 
        # Validate configuration
-       if [ "$system" = "localhost" -o "$system" = "127.0.0.1" ]; then
+       if [[ "$system" = "localhost" || "$system" = "127.0.0.1" ]]; then
                # Local system
                local=1
                compress=0
@@ -439,7 +457,7 @@ for f in $sys; do
 
        sys_target="$target/$fname"
        sys_root="$sys_target"
-       if [ "$DRYRUN" -eq 0 -a ! -e "$sys_target" ]; then
+       if [[ "$DRYRUN" -eq 0 && ! -e "$sys_target" ]]; then
                if [ $generations -gt 0 ]; then
                        CreateSubvolume "$sys_target"
                else
@@ -451,7 +469,7 @@ for f in $sys; do
                fi
        fi
 
-       if [ "$local" -eq 0 -a "$ping" -ne 0 ]; then
+       if [[ "$local" -eq 0 && "$ping" -ne 0 ]]; then
                # Check if system is alive
                ping -c 1 "$system" >/dev/null 2>&1
                if [ $? -ne 0 ]; then
@@ -472,7 +490,7 @@ for f in $sys; do
 
                Initialize_Last_SysTarget_Snapshot "$sys_target" || continue
 
-               if [ -n "$last" -a ! -e "$last/.stamp" ]; then
+               if [[ -n "$last" && ! -e "$last/.stamp" ]]; then
                        # Old backup directory without "stamp file", continue
                        echo "Found incomplete snapshot in \"$last\", reusing and renaming it ..."
                        RenameSubvolume "$last" "$sys_target"
@@ -522,23 +540,46 @@ for f in $sys; do
        fi
 
        # prepare (remote) command ...
-       cmd="rsync --archive"
-       [ "$compress" -ne 0 ] && cmd="$cmd --compress"
-       [ "$local" -eq 0 ] && cmd="$cmd --rsh=\"$ssh_cmd\""
-       cmd="$cmd --delete --delete-excluded --sparse"
-       [ "$VERBOSE" -gt 0 ] && cmd="$cmd --progress"
-       if [ "$source_root" = "$default_source_root" ]; then
-               cmd="$cmd --exclude=/dev --exclude=/proc --exclude=/sys"
-               cmd="$cmd --exclude=/run --exclude=/tmp --exclude=/var/tmp"
-               cmd="$cmd --exclude=/media --exclude=/mnt --exclude=/net"
-               cmd="$cmd --exclude=/var/cache/apt --exclude=/var/log"
+       if [[ "$backup_type" == "rsync" ]]; then
+               cmd="$rsync --archive"
+               [ "$compress" -ne 0 ] && cmd="$cmd --compress"
+               [ "$local" -eq 0 ] && cmd="$cmd --rsh=\"$ssh_cmd\""
+               cmd="$cmd --delete --delete-excluded --sparse"
+               if [ "$VERBOSE" -gt 0 ]; then
+                       [ "$rsync_proto" -ge 31 ] \
+                               && cmd="$cmd --info=progress2" \
+                               || cmd="$cmd --progress"
+               fi
+               if [ "$source_root" = "$default_source_root" ]; then
+                       for dir in \
+                               "/dev/**" \
+                               "/media/**" \
+                               "/mnt/**" \
+                               "/net/**" \
+                               "/proc/**" \
+                               "/run/**" \
+                               "/sys/**" \
+                               "/tmp/**" \
+                               "/var/cache/apt/**" \
+                               "/var/log/**" \
+                               "/var/tmp/**" \
+                       ; do
+                               cmd="$cmd --exclude=$dir"
+                       done
+               fi
+               [ -n "$exclude_args_add" ] && cmd="$cmd $exclude_args_add"
+               for dir in $exclude_dirs_add; do
+                       cmd="$cmd --exclude=$dir"
+               done
+               [ -n "$rsync_args_add" ] && cmd="$cmd $rsync_args_add"
+
+               [ "$local" -eq 0 ] \
+                       && cmd="$cmd ${user}@${system}:$source_root $sys_target/" \
+                       || cmd="$cmd $source_root $sys_target/"
+       else
+               echo "Backup type \"$backup_type\" undefined, \"$system\" skipped!"
+               echo; continue
        fi
-       [ -n "$exclude_args_add" ] && cmd="$cmd $exclude_args_add"
-       [ -n "$rsync_args_add" ] && cmd="$cmd $rsync_args_add"
-
-       [ "$local" -eq 0 ] \
-               && cmd="$cmd ${user}@${system}:$source_root $sys_target/" \
-               || cmd="$cmd $source_root $sys_target/"
 
        echo "Backing up to \"$sys_target\" ..."
        echo -n "Start date: "; date
@@ -561,7 +602,7 @@ for f in $sys; do
        fi
 
        echo -n "End date: "; date
-       if [ $ret -eq 0 -o $ret -eq 24 ]; then
+       if [[ $ret -eq 0 || $ret -eq 24 ]]; then
                [ $ret -eq 24 ] && count_ok_vanished=$count_ok_vanished+1
 
                echo "System \"$system\" completed with status $ret, OK."
@@ -585,7 +626,7 @@ for f in $sys; do
                # Clean up old generations
                declare -i gen_count=$generations+2
                to_delete=$(ls -1t "$sys_root" 2>/dev/null | tail -n+$gen_count | sort)
-               if [ -n "$to_delete" -a $ok -eq 1 ]; then
+               if [[ -n "$to_delete" && $ok -eq 1 ]]; then
                        [ "$DRYRUN" -eq 0 ] \
                                && echo "Deleting old backup generations (keep $generations) ..." \
                                || echo " *** Trial run, not deleting old generations:"
@@ -618,10 +659,27 @@ done
 
 sync
 
-paths=$( echo $destinations | sed -e 's/ /\n/g' | sort | uniq )
-if [ "$DRYRUN" -eq 0 -a -n "$paths" ]; then
-       df -h $paths
-       echo
+if [ "$DRYRUN" -eq 0 ]; then
+       paths=""
+       paths_zfs=""
+       for dest in $(echo $destinations | sed -e 's/ /\n/g' | sort | uniq); do
+               fs=$(GetFS "$dest")
+               case $fs in
+                 "zfs" )
+                       paths_zfs="$paths_zfs $dest"
+                       ;;
+                 *)
+                       paths="$paths $dest"
+               esac
+       done
+       if [ -n "$paths" ]; then
+               df -h $paths
+               echo
+       fi
+       if [ -n "$paths_zfs" ]; then
+               zfs list $paths_zfs
+               echo
+       fi
 fi
 
 CleanUp
@@ -639,6 +697,8 @@ if [ $count_started -ne $count_ok ]; then
        echo "----->  THERE HAVE BEEN ERRORS!  <-----"
        echo
        exit 6
+elif [ $count_all -ne $count_started ]; then
+       exit 7
 fi
 
 # -eof-